<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class KdsFilial extends CrudWithParameterBag {

    protected $parameterBagColumns = array();

    public function __construct ($dataSourceManager, $parameterBag, $entityManager, $environment, $crudService, $utilService) {
	    parent::__construct($dataSourceManager, $parameterBag);
        $this->entityManager    = $entityManager;
        $this->environment      = $environment;
        $this->crudService      = $crudService;
        $this->utilService              = $utilService;
    }


    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSourceName            = $this->dataSourceName = 'vnd09700_kds_filial';
        $conditions                = $this->utilService->getParamsAsArray($request);
        $conditions['CDOPERADOR']  = $this->environment->getCdOperador();

        if($this->environment->getIdUtlPerfilFilial() == 'S'){
            $conditions['NRPERFIL'] = $this->environment->getNrPerfil();
            $this->dataSourceName = 'vnd09700_kds_filial_perfil' ;
        } else {
            $this->dataSourceName = 'vnd09700_kds_filial' ;
        }

        $dataSourceFilter          = self::prepareParameters($conditions);
        for($i = 0; $i < count($conditions); $i++) {
            if(strpos($dataSourceFilter[$i]["columnName"], '|') != false) {
                $dataSourceFilter[$i]["operator"] = "MAPPED_LIKE_ALL";
                if(!is_array($dataSourceFilter[$i]['value'])){
                    $value = $dataSourceFilter[$i]['value'];
                    unset($dataSourceFilter[$i]['value']);
                    $dataSourceFilter[$i]['value']['0']['_ALL'] = $value;
                }
            }
        }

        $this->parameterBagColumns = array('NRPERFIL', 'CDOPERADOR');

        $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $dataSourceFilter,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        parent::find($newRequest, $response);
    }

    private function prepareParameters($conditions) {
        foreach($conditions as $key => $value) {
            $dataSourceFilter[] = array(
                "columnName" => $key,
                "operator"=> "=",
                "value"=> $value
            );
        }


        return $dataSourceFilter;
    }
}