<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelMoviProdHora {
    
    protected $relMoviProdHora;
    protected $util;

    public function __construct (Utilities\Util $util,  Services\RelMoviProdHoraService $relMoviProdHora){
        $this->utilService = $util;
        $this->reportService = $relMoviProdHora;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        ini_set('max_execution_time', 1800);
		ini_set('memory_limit', '512M');
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        $return = $this->reportService->getData($conditions);
        $arrayFinal = [];
        
        foreach ($return as $produto) {
            
            if(!array_key_exists(($produto['CDPRODUTO'].$produto['CDFILIAL']), $arrayFinal)){
                $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']] = $produto;
            }
            
            if($conditions['IDTPRELATORIO'] == 'VALOR') {
                
                $valorTotal = $produto['TOTALVEND'];
                
                $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['HR'.$produto['HORAPEDIDO']] = $valorTotal;
                $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['TOTAL'] = $valorTotal + $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['TOTAL'];
            
                
            } else {
                
                $valorTotal = $produto['TOT'];
                
                $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['HR'.$produto['HORAPEDIDO']] = $valorTotal;
                $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['TOTAL'] = $valorTotal + $arrayFinal[$produto['CDPRODUTO'].$produto['CDFILIAL']]['TOTAL'];
            
            }
            
        }
        
        $arrayFinal = array_values($arrayFinal);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('orm00011_relMoviProdHora', $arrayFinal));
    }
    
}